Attribute VB_Name = "ShellFileInfo"
Option Explicit

Public Const MAX_PATH = 260
Public Const ILD_TRANSPARENT = &H1

Public Const SHGFI_TYPENAME = &H400&
Public Const SHGFI_DISPLAYNAME = &H200
Public Const SHGFI_LARGEICON = &H0
Public Const SHGFI_SMALLICON = &H1
Public Const SHGFI_SYSICONINDEX = &H4000
Public Const SHGFI_SHELLICONSIZE = &H4
Public Const SHGFI_EXETYPE = &H2000
Public Const BASIC_SHGFI_FLAGS = SHGFI_TYPENAME Or SHGFI_SHELLICONSIZE _
             Or SHGFI_SYSICONINDEX Or SHGFI_DISPLAYNAME Or _
             SHGFI_EXETYPE


Type SHFILEINFO
    hIcon As Long
    iIcon As Long
    dwAttributes As Long
    szDisplayName As String * MAX_PATH
    szTypeName As String * 80
End Type

Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
Declare Function ImageList_Draw Lib "comctl32.dll" (ByVal himl&, ByVal i&, ByVal hDCDest&, ByVal x&, ByVal y&, ByVal flags&) As Long
Sub DisplayIcons(fn As String, Small As PictureBox, Large As PictureBox)
Dim hImgSmall As Long, hImgLarge As Long
Dim FileInfo As SHFILEINFO
Dim r As Long

Small.Cls
Large.Cls

'hImgXXXXX sind Handles auf ImageLists
hImgSmall = SHGetFileInfo(fn, 0&, FileInfo, Len(FileInfo), BASIC_SHGFI_FLAGS Or SHGFI_SMALLICON)
hImgLarge = SHGetFileInfo(fn, 0&, FileInfo, Len(FileInfo), BASIC_SHGFI_FLAGS Or SHGFI_LARGEICON)

'zeichnet die Symbole ber die "ImageList_Draw"-Fkt.
r = ImageList_Draw(hImgSmall&, FileInfo.iIcon, Small.hDC, 0, 0, ILD_TRANSPARENT)
r = ImageList_Draw(hImgLarge&, FileInfo.iIcon, Large.hDC, 0, 0, ILD_TRANSPARENT)

Small.Refresh
Large.Refresh
End Sub


Function GetFileType(sFilename As String) As String
Dim FileInfo As SHFILEINFO, ret As Long

ret = SHGetFileInfo(ByVal sFilename, 0&, FileInfo, Len(FileInfo), SHGFI_TYPENAME)

If ret Then
    If InStr(FileInfo.szTypeName, vbNullChar) > 1 Then
        GetFileType = Left$(FileInfo.szTypeName, InStr(FileInfo.szTypeName, vbNullChar) - 1)
    Else
        GetFileType = "(nicht verknpft)"
    End If
End If
End Function

Function GetDisplayName(sFilename As String) As String
Dim FileInfo As SHFILEINFO, ret As Long

ret = SHGetFileInfo(ByVal sFilename, 0&, FileInfo, Len(FileInfo), SHGFI_DISPLAYNAME)

If ret Then
    If InStr(FileInfo.szDisplayName, vbNullChar) > 1 Then
        GetDisplayName = Left$(FileInfo.szDisplayName, InStr(FileInfo.szDisplayName, vbNullChar) - 1)
    End If
End If
End Function


